<template>
    <div id="users">

        <!-- Data Table -->
        <div class="row">
            <div class="col-md-12">
                <div class="nav-tabs-custom tab-nexus">
                    <ul class="nav nav-tabs">
                        <!-- tab : ALL USERS -->
                        <li class="active">
                            <a href="#allUsers" data-toggle="tab">
                                ALL
                            </a>
                        </li>
                        <!-- tab : ACTIVE USERS -->
                        <li class="">
                            <a href="#activeUsers" data-toggle="tab">
                                Active
                            </a>
                        </li>
                        <!-- tab : PENDING USERS -->
                        <li class="">
                            <a href="#pendingUsers" data-toggle="tab">
                                Pending
                            </a>
                        </li>
                    </ul>
                    <div class="tab-content">

                        <!-- tab : ALL USERS -->
                        <div class="active tab-pane" id="allUsers">

                            <table id="allUsersTable" class="table table-bordered table-striped">
                                <thead>
                                    <tr>
                                        <th>
                                            #
                                        </th>
                                        <th>
                                            PHOTO
                                        </th>
                                        <th>
                                            NAME
                                        </th>
                                        <th>
                                            EMAIL
                                        </th>
                                        <th>
                                            CREATED AT
                                        </th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            1
                                        </td>
                                        <td>
                                            ...
                                        </td>
                                        <td>
                                            JOHN
                                        </td>
                                        <td>
                                            john@doe.com
                                        </td>
                                        <td>
                                            2020-04-08
                                        </td>
                                    </tr>
                                </tbody>

                            </table>

                        </div>
                        <!-- /.tab-pane -->

                        <!-- tab : ACTIVE USERS -->
                        <div class="tab-pane" id="activeUsers">

                            <h3>afventende brugere</h3>

                        </div>
                        <!-- /.tab-pane -->

                        <!-- tab : PENDING USERS -->
                        <div class="tab-pane" id="pendingUsers">

                            <h3>afventende brugere</h3>

                        </div>
                        <!-- /.tab-pane -->

                    </div>
                    <!-- /.tab-content -->
                </div>
                <!-- /.nav-tabs-custom -->
            </div>
        </div>

    </div>
</template>

<script>

    // importing Vuex maps
    import { mapActions, mapGetters } from "vuex";

    let every = {
        oneSecond       : 1000,
        twoSeconds      : 2000,
        treeSeconds     : 3000,
        fourSeconds     : 4000,
        oneMinute       : 60000,
        twoMinutes      : 120000,
        threeMinutes    : 180000,
        fourMinutes     : 240000,
        fifteenMinutes  : 900000,
        oneHour         : 3600000,
        twoHour         : 7200000,
        threeHour       : 10800000,
        fourHour        : 14400000
    };

    export default {
        name: "users",
        components: {

            // ...

        },
        created() {

            // ...
            this.checkForNewUsers()

        },
        mounted() {

            /**
             * @type {jQuery}
             *
             * jQuery Datatables
             * https://datatables.net/
             */
            this.dataTable = $('#allUsersTable').DataTable({
                //"dom": 'lfrtipB',
                "paging":   true,
                "pagingType": "full_numbers",
                "ordering": true,
                "info":     true,
                "lengthMenu": [
                    [
                        14,
                        28,
                        42,
                        -1
                    ],
                    [
                        14,
                        28,
                        42,
                        "All"
                    ]
                ],
                "buttons": [
                    'print', 'excel', 'pdf'
                ],
                "language": {
                    "decimal":          "",
                    "thousands":        ",",
                    "emptyTable":       "No data available in table",
                    "info":             this.locales['view.other.monitor.datatable_info'],
                    "infoEmpty":        this.locales['view.other.monitor.datatable_info_empty'],
                    "infoFiltered":     this.locales['view.other.monitor.datatable_info_filtered'],
                    "infoPostFix":      "",
                    "lengthMenu":       this.locales['view.other.monitor.datatable_length_menu'],
                    "loadingRecords":   "Loading...",
                    "processing":       "Processing...",
                    "search":           "Search:",
                    "zeroRecords":      this.locales['view.other.monitor.datatable_zero_records'],
                    "paginate": {
                        "first":        "First",
                        "last":         "Last",
                        "next":         "Next",
                        "previous":     "Previous"
                    },
                    "aria": {
                        "sortAscending":    ": activate to sort column ascending",
                        "sortDescending":   ": activate to sort column descending"
                    }
                }
            })

        },
        data() {
            return {

                dataTable: null,
                usersCheck: null,

            };
        },
        computed: {

            ...mapGetters({
                users: 'users/users',
                locales: 'locale/locales'
            })

        },
        methods: {

            ...mapActions({

                fetchUsers: 'users/fetchUsers'

            }),

            checkForNewUsers () {
                this.usersCheck = setInterval(() => {
                    this.fetchUsers()
                }, every.fourSeconds)
            }

        }
    }

</script>

<!-- eslint-disable -->
<style lang="scss" scoped>

// ...

</style>